import { AItem, HasInTopic } from './AItem'
import * as logger from './log'
import { mqttHandler } from './MqttDispatcher'

export class SwitchAdaptor extends AItem implements HasInTopic {
    private state: string
    private inTopic: string
    private actionStateTopic: string
    
    constructor(floor: string, room: string, item: string) {
        super(floor, room, item)
        this.actionStateTopic = `${this.topicFirstPart}/state`
        this.inTopic = `${this.topicFirstPart}/in`
        this.subscribeTopics = [ this.inTopic ]
        this.state = 'OFF'
    }

    getInTopic() : string {
        return this.inTopic
    }


    processMessage(topic: string, payload: string) : void {
        switch (topic) {
            case this.inTopic:
                switch (payload) {
                    case 'SHORT':
                        if (this.state == 'OFF') {
                            this.state = 'ON'
                        } else {
                            this.state = 'OFF'
                        }
                        mqttHandler.send(this.actionStateTopic, this.state, true)
                        break
                }  
                break
        }
    }
}


